//Schematic to java Structure by jajo_11 | inspired by "MITHION'S .SCHEMATIC TO JAVA CONVERTINGTOOL"

package com.hbm.world.dungeon;

import java.util.Random;

import com.hbm.blocks.ModBlocks;
import com.hbm.config.GeneralConfig;
import com.hbm.lib.HbmChestContents;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

public class Factory extends WorldGenerator
{
	Block Block1 = ModBlocks.steel_scaffold;
	Block Block2 = ModBlocks.red_barrel;
	Block Block4 = ModBlocks.steel_wall;
	Block Block5 = ModBlocks.reinforced_light;
	
	int s4 = 8;
	
	protected Block[] GetValidSpawnBlocks()
	{
		return new Block[]
		{
			Blocks.grass,
			Blocks.dirt,
			Blocks.stone,
			Blocks.sand,
			Blocks.sandstone,
		};
	}

	public boolean LocationIsValidSpawn(World world, int x, int y, int z)
 {

		Block checkBlock = world.getBlock(x, y - 1, z);
		Block blockAbove = world.getBlock(x, y , z);
		Block blockBelow = world.getBlock(x, y - 2, z);

		for (Block i : GetValidSpawnBlocks())
		{
			if (blockAbove != Blocks.air)
			{
				return false;
			}
			if (checkBlock == i)
			{
				return true;
			}
			else if (checkBlock == Blocks.snow_layer && blockBelow == i)
			{
				return true;
			}
			else if (checkBlock.getMaterial() == Material.plants && blockBelow == i)
			{
				return true;
			}
		}
		return false;
	}

	@Override
	public boolean generate(World world, Random rand, int x, int y, int z)
	{
		int i = rand.nextInt(1);

		if(i == 0)
		{
		    generate_r0(world, rand, x, y, z);
		}

       return true;

	}

	public boolean generate_r0(World world, Random rand, int x, int y, int z)
	{
		if(!LocationIsValidSpawn(world, x + 7, y, z + 15))
		{
			return false;
		}

		for(int i = 0; i < 15; i++)
		{
			for(int j = 0; j < 5; j++)
			{
				for(int k = 0; k < 29; k++)
				{
					world.setBlock(x + i, y + j, z + k, Blocks.air, 0, 3);
				}
			}
		}

		for(int i = 0; i < 15; i++)
		{
			for(int j = 0; j < 5; j++)
			{
				for(int k = 0; k < 29; k++)
				{
					world.setBlock(x + i, y + j - 6, z + k, Blocks.cobblestone, 0, 3);
				}
			}
		}
		
		world.setBlock(x + 0, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + -1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 1, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 2, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 3, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 4, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 5, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 6, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 7, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 8, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 9, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 10, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 11, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 12, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 13, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 14, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 15, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 16, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 17, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 18, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 19, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 4, y + -1, z + 19, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + -1, z + 19, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 19, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 20, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 4, y + -1, z + 20, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + -1, z + 20, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 20, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 21, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 4, y + -1, z + 21, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + -1, z + 21, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 21, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 22, Blocks.monster_egg, 5, 3);
		world.setBlock(x + 4, y + -1, z + 22, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + -1, z + 22, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 22, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 23, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 24, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 16, y + -1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 25, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 16, y + -1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 26, Blocks.monster_egg, 1, 3);
		world.setBlock(x + 7, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 26, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 16, y + -1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 27, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 16, y + -1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 2, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 3, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 4, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 5, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 6, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 7, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 8, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 9, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 10, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 11, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 12, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 13, y + -1, z + 28, Blocks.cobblestone, 0, 3);
		world.setBlock(x + 14, y + -1, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 15, y + -1, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + -1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 0, z + 3, Blocks.crafting_table, 0, 3);
		world.setBlock(x + 13, y + 0, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 4, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 0, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 9, y + 0, z + 4, Blocks.chest, 5, 3);
		world.setBlockMetadataWithNotify(x + 9, y + 0, z + 4, 5, 3);
		if(world.getBlock(x + 9, y + 0, z + 4) == Blocks.chest)
		{
			WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.modGeneric, (TileEntityChest)world.getTileEntity(x + 9, y + 0, z + 4), rand.nextInt(2)+ 8);
		}
        world.setBlock(x + 13, y + 0, z + 4, Blocks.hopper, 3, 3);
		world.setBlock(x + 14, y + 0, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 5, Blocks.chest, 4, 3);
		world.setBlock(x + 14, y + 0, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 6, Blocks.hopper, 2, 3);
		world.setBlock(x + 14, y + 0, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 0, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 0, z + 9, Blocks.crafting_table, 0, 3);
		world.setBlock(x + 13, y + 0, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 10, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 0, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 9, y + 0, z + 10, Blocks.chest, 5, 3);
		world.setBlockMetadataWithNotify(x + 9, y + 0, z + 10, 5, 3);
		if(world.getBlock(x + 9, y + 0, z + 10) == Blocks.chest)
		{
			WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.modGeneric, (TileEntityChest)world.getTileEntity(x + 9, y + 0, z + 10), rand.nextInt(2)+ 8);
		}
        world.setBlock(x + 13, y + 0, z + 10, Blocks.hopper, 3, 3);
		world.setBlock(x + 14, y + 0, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 11, Blocks.chest, 4, 3);
		world.setBlock(x + 14, y + 0, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 12, Blocks.hopper, 2, 3);
		world.setBlock(x + 14, y + 0, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 0, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 0, z + 15, Blocks.crafting_table, 0, 3);
		world.setBlock(x + 13, y + 0, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 16, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 0, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 9, y + 0, z + 16, Blocks.chest, 5, 3);
		world.setBlockMetadataWithNotify(x + 9, y + 0, z + 16, 5, 3);
		if(world.getBlock(x + 9, y + 0, z + 16) == Blocks.chest)
		{
			WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.modGeneric, (TileEntityChest)world.getTileEntity(x + 9, y + 0, z + 16), rand.nextInt(2)+ 8);
		}
        world.setBlock(x + 13, y + 0, z + 16, Blocks.hopper, 3, 3);
		world.setBlock(x + 14, y + 0, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 17, Blocks.chest, 4, 3);
		world.setBlock(x + 14, y + 0, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 18, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 0, z + 18, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 0, z + 18, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 0, z + 18, Blocks.hopper, 2, 3);
		world.setBlock(x + 14, y + 0, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 19, Blocks.stone_brick_stairs, 0, 3);
		world.setBlock(x + 4, y + 0, z + 19, Blocks.stone_brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 0, z + 19, Blocks.stone_brick_stairs, 1, 3);
		world.setBlock(x + 13, y + 0, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 20, Blocks.stone_brick_stairs, 0, 3);
		world.setBlock(x + 4, y + 0, z + 20, Blocks.iron_block, 0, 3);
		world.setBlock(x + 5, y + 0, z + 20, Blocks.stone_brick_stairs, 1, 3);
		world.setBlock(x + 7, y + 0, z + 20, ModBlocks.anvil_iron, 4, 3);
		world.setBlock(x + 14, y + 0, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 21, Blocks.stone_brick_stairs, 0, 3);
		world.setBlock(x + 4, y + 0, z + 21, Blocks.iron_block, 0, 3);
		world.setBlock(x + 5, y + 0, z + 21, Blocks.stone_brick_stairs, 1, 3);
		world.setBlock(x + 7, y + 0, z + 21, ModBlocks.anvil_iron, 4, 3);
		world.setBlock(x + 14, y + 0, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 22, Blocks.stone_brick_stairs, 0, 3);
		world.setBlock(x + 4, y + 0, z + 22, Blocks.lava, 2, 3);
		world.setBlock(x + 5, y + 0, z + 22, Blocks.stone_brick_stairs, 1, 3);
		world.setBlock(x + 14, y + 0, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 0, z + 23, Blocks.lava, 10, 3);
		world.setBlock(x + 5, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 0, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 5, y + 0, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 0, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 0, z + 24, Blocks.stone_brick_stairs, 6, 3);
		world.setBlock(x + 14, y + 0, z + 24, Block1, s4, 3);
		world.setBlock(x + 0, y + 0, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 25, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 0, z + 25, Blocks.chest, 3, 3);
		world.setBlockMetadataWithNotify(x + 4, y + 0, z + 25, 3, 3);
		if(world.getBlock(x + 4, y + 0, z + 25) == Blocks.chest)
		{
			WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.expensive, (TileEntityChest)world.getTileEntity(x + 4, y + 0, z + 25), rand.nextInt(2)+ 6);
		}
        world.setBlock(x + 5, y + 0, z + 25, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 0, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 0, z + 25, Blocks.stone_brick_stairs, 5, 3);
		world.setBlock(x + 14, y + 0, z + 25, Block1, s4, 3);
		world.setBlock(x + 0, y + 0, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 0, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 5, y + 0, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 0, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 0, z + 26, Blocks.stone_brick_stairs, 7, 3);
		world.setBlock(x + 14, y + 0, z + 26, Block1, s4, 3);
		world.setBlock(x + 0, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 27, Block1, s4, 3);
		world.setBlock(x + 0, y + 0, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 0, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 0, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 1, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 2, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 3, Blocks.stone_brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 1, z + 3, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 4, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 1, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 1, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 4, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 4, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 5, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 1, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 5, Blocks.stone_brick_stairs, 4, 3);
		world.setBlock(x + 14, y + 1, z + 5, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 6, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 6, ModBlocks.deco_steel, 3, 3);
		world.setBlock(x + 8, y + 1, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 6, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 6, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 7, Blocks.stone_brick_stairs, 3, 3);
		world.setBlock(x + 14, y + 1, z + 7, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 8, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 9, Blocks.stone_brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 1, z + 9, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 10, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 1, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 1, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 10, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 10, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 11, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 1, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 11, Blocks.stone_brick_stairs, 4, 3);
		world.setBlock(x + 14, y + 1, z + 11, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 12, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 12, ModBlocks.deco_steel, 3, 3);
		world.setBlock(x + 8, y + 1, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 12, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 12, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 13, Blocks.stone_brick_stairs, 3, 3);
		world.setBlock(x + 14, y + 1, z + 13, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 14, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 15, Blocks.stone_brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 1, z + 15, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 16, ModBlocks.deco_lead, 5, 3);
		world.setBlock(x + 6, y + 1, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 16, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 16, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 17, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 1, z + 17, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 17, Blocks.stone_brick_stairs, 4, 3);
		world.setBlock(x + 14, y + 1, z + 17, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 18, Block2, 5, 3);
		world.setBlock(x + 6, y + 1, z + 18, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 1, z + 18, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 13, y + 1, z + 18, ModBlocks.machine_electric_furnace_off, 4, 3);
		world.setBlock(x + 14, y + 1, z + 18, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 19, Blocks.stone_brick_stairs, 3, 3);
		world.setBlock(x + 14, y + 1, z + 19, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 20, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 21, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 22, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 1, z + 23, Blocks.lava, 2, 3);
		world.setBlock(x + 5, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 1, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 5, y + 1, z + 24, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 1, z + 24, Blocks.lit_furnace, 5, 3);
		world.setBlock(x + 7, y + 1, z + 24, Blocks.heavy_weighted_pressure_plate, 0, 3);
		world.setBlock(x + 14, y + 1, z + 24, Block1, s4, 3);
		world.setBlock(x + 0, y + 1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 25, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 1, z + 25, Blocks.lava, 0, 3);
		world.setBlock(x + 5, y + 1, z + 25, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 1, z + 25, Blocks.lit_furnace, 5, 3);
		world.setBlock(x + 7, y + 1, z + 25, Blocks.heavy_weighted_pressure_plate, 0, 3);
		world.setBlock(x + 14, y + 1, z + 25, Block1, s4, 3);
		world.setBlock(x + 0, y + 1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 4, y + 1, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 5, y + 1, z + 26, Blocks.lava, 0, 3);
		world.setBlock(x + 6, y + 1, z + 26, Blocks.lit_furnace, 5, 3);
		world.setBlock(x + 7, y + 1, z + 26, Blocks.heavy_weighted_pressure_plate, 0, 3);
		world.setBlock(x + 14, y + 1, z + 26, Block1, s4, 3);
		world.setBlock(x + 0, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 1, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 27, Block1, s4, 3);
		world.setBlock(x + 0, y + 1, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 1, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 2, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 3, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 4, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 5, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 6, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 7, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 8, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 9, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 10, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 11, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 12, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 13, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 1, z + 29, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 4, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 5, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 10, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 11, y + 2, z + 0, Blocks.glass, 0, 3);
		world.setBlock(x + 12, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 1, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 1, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 2, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 2, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 3, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 3, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 3, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 3, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 4, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 4, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 4, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 5, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 5, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 5, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 6, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 7, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 7, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 7, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 7, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 8, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 8, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 8, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 8, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 9, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 9, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 10, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 10, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 10, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 11, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 11, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 11, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 12, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 7, y + 2, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 8, y + 2, z + 12, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 12, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 13, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 8, y + 2, z + 13, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 14, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 15, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 15, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 15, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 16, Blocks.glass, 0, 3);
		world.setBlock(x + 6, y + 2, z + 16, ModBlocks.deco_steel, 0, 3);
		world.setBlock(x + 14, y + 2, z + 16, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 19, Blocks.glass, 0, 3);
		world.setBlock(x + 14, y + 2, z + 19, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 20, Blocks.glass, 0, 3);
		world.setBlock(x + 14, y + 2, z + 20, Blocks.glass, 0, 3);
		world.setBlock(x + 0, y + 2, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 2, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 2, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 2, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 2, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 2, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 5, y + 2, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 6, y + 2, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 2, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 2, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 2, z + 24, Block1, s4, 3);
		world.setBlock(x + 0, y + 2, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 2, z + 25, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 2, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 25, Blocks.lit_furnace, 5, 3);
		world.setBlock(x + 14, y + 2, z + 25, Block1, s4, 3);
		world.setBlock(x + 0, y + 2, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 2, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 14, y + 2, z + 26, Block1, s4, 3);
		world.setBlock(x + 0, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 2, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 27, Block1, s4, 3);
		world.setBlock(x + 0, y + 2, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 2, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 2, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 6, y + 2, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 14, y + 2, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 2, z + 29, Blocks.glass, 0, 3);
		world.setBlock(x + 10, y + 2, z + 29, Blocks.glass, 0, 3);
		world.setBlock(x + 11, y + 2, z + 29, Blocks.glass, 0, 3);
		world.setBlock(x + 12, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 2, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 0, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 5, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 5, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 10, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 10, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 15, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 15, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 20, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 20, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 3, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 3, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 3, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 5, y + 3, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 23, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 3, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 24, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 3, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 25, Block1, s4, 3);
		world.setBlock(x + 0, y + 3, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 26, Block1, s4, 3);
		world.setBlock(x + 0, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 3, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 28, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 3, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 3, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 4, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 7, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 8, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 9, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 10, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 11, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 12, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 13, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 14, y + 4, z + 0, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 1, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 14, y + 4, z + 1, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 2, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 2, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 2, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 2, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 2, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 2, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 2, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 2, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 2, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 2, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 2, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 3, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 3, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 3, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 3, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 3, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 3, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 3, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 3, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 3, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 3, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 3, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 4, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 4, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 4, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 4, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 4, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 4, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 4, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 4, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 4, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 4, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 4, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 5, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 5, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 5, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 5, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 5, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 5, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 5, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 5, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 5, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 5, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 5, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 6, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 6, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 6, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 6, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 6, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 6, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 6, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 6, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 6, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 6, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 6, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 7, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 7, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 7, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 7, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 7, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 7, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 7, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 7, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 7, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 7, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 7, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 8, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 8, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 8, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 8, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 8, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 8, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 8, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 8, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 8, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 8, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 8, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 9, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 9, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 9, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 9, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 9, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 9, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 9, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 9, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 9, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 9, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 9, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 10, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 10, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 10, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 10, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 10, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 10, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 10, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 10, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 10, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 10, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 10, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 11, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 11, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 11, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 11, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 11, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 11, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 11, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 11, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 11, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 11, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 11, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 12, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 12, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 12, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 12, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 12, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 12, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 12, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 12, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 12, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 12, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 12, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 13, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 13, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 13, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 13, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 13, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 13, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 13, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 13, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 13, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 13, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 13, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 14, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 14, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 14, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 14, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 14, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 14, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 14, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 14, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 14, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 14, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 14, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 15, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 15, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 15, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 15, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 15, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 15, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 15, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 15, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 15, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 15, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 15, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 16, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 16, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 16, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 16, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 16, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 16, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 16, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 16, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 16, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 16, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 16, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 17, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 17, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 17, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 17, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 17, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 17, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 17, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 17, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 17, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 17, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 17, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 18, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 18, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 18, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 18, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 18, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 18, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 18, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 18, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 18, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 18, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 18, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 19, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 19, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 19, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 19, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 19, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 19, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 19, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 19, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 19, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 19, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 19, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 20, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 20, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 20, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 20, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 20, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 20, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 20, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 20, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 20, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 20, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 20, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 21, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 21, Block4, 4, 3);
		world.setBlock(x + 2, y + 4, z + 21, Block5, 0, 3);
		world.setBlock(x + 3, y + 4, z + 21, Block4, 5, 3);
		world.setBlock(x + 6, y + 4, z + 21, Block4, 4, 3);
		world.setBlock(x + 7, y + 4, z + 21, Block5, 0, 3);
		world.setBlock(x + 8, y + 4, z + 21, Block4, 5, 3);
		world.setBlock(x + 10, y + 4, z + 21, Block4, 4, 3);
		world.setBlock(x + 11, y + 4, z + 21, Block5, 0, 3);
		world.setBlock(x + 12, y + 4, z + 21, Block4, 5, 3);
		world.setBlock(x + 14, y + 4, z + 21, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 22, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 14, y + 4, z + 22, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 23, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 4, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 4, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 4, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 4, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 4, z + 23, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 24, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 4, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 4, z + 24, Blocks.monster_egg, 2, 3);
		world.setBlock(x + 0, y + 4, z + 25, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 4, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 4, z + 25, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 4, z + 26, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 4, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 4, z + 26, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 4, z + 27, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 4, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 4, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 4, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 4, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 4, z + 27, Blocks.stonebrick, 0, 3);
		world.setBlock(x + 0, y + 4, z + 28, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 14, y + 4, z + 28, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 1, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 2, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 3, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 4, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 5, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 6, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 7, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 8, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 9, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 10, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 11, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 12, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 13, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 14, y + 4, z + 29, Blocks.stonebrick, 3, 3);
		world.setBlock(x + 0, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 5, z + 0, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 1, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 5, z + 5, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 6, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 5, z + 10, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 5, z + 10, Blocks.brick_stairs, 2, 3);

		generate_r02(world, rand, x, y, z);
		return true;

	}
	public boolean generate_r02(World world, Random rand, int x, int y, int z)
	{

		world.setBlock(x + 0, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 11, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 5, z + 15, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 16, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 5, z + 20, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 21, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 5, z + 29, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 6, z + 1, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 2, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 6, z + 6, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 7, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 6, z + 11, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 12, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 6, z + 16, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 17, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 6, z + 21, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 22, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 6, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 6, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 6, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 6, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 12, y + 6, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 13, y + 6, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 0, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 7, z + 2, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 3, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 7, z + 7, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 8, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 7, z + 12, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 13, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 7, z + 17, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 18, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 7, z + 22, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 7, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 7, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 7, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 7, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 12, y + 7, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 13, y + 7, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 0, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 8, z + 3, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 8, z + 4, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 8, z + 8, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 8, z + 9, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 8, z + 13, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 8, z + 14, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 8, z + 18, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 8, z + 19, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 8, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 8, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 11, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 12, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 13, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 14, y + 8, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 1, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 12, y + 8, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 13, y + 8, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 1, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 8, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 9, y + 8, z + 28, Blocks.brick_block, 0, 3);
		world.setBlock(x + 10, y + 8, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 12, y + 8, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 13, y + 8, z + 28, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 0, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 9, z + 4, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 9, z + 9, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 9, z + 14, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 0, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 3, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 6, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 7, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 9, z + 19, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 9, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 9, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 9, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 9, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 0, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 1, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 9, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 7, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 8, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 9, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 10, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 11, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 12, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 13, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 14, y + 9, z + 24, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 9, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 9, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 9, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 9, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 9, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 9, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 9, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 9, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 9, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 10, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 10, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 10, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 10, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 10, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 10, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 10, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 10, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 10, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 10, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 10, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 10, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 10, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 10, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 10, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 10, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 11, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 11, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 11, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 11, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 11, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 11, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 11, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 11, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 11, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 11, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 11, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 11, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 11, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 11, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 11, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 11, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 12, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 12, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 12, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 12, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 12, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 12, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 12, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 12, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 12, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 12, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 12, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 12, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 12, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 12, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 12, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 12, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 13, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 13, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 13, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 13, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 13, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 13, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 13, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 13, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 13, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 13, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 13, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 13, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 13, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 13, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 13, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 13, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 14, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 14, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 14, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 14, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 14, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 14, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 14, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 14, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 14, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 14, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 14, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 14, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 14, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 14, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 14, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 14, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 15, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 15, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 15, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 15, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 15, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 15, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 15, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 15, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 15, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 15, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 15, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 15, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 15, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 15, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 15, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 15, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 16, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 16, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 16, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 16, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 16, z + 23, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 2, y + 16, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 16, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 16, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 16, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 16, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 16, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 16, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 16, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 16, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 16, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 16, z + 27, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 17, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 17, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 17, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 17, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 17, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 17, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 17, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 17, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 17, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 17, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 17, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 17, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 18, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 18, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 18, z + 23, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 18, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 18, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 18, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 18, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 18, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 18, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 2, y + 18, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 18, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 18, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 18, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 18, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 18, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 18, z + 27, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 19, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 4, y + 19, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 5, y + 19, z + 23, Blocks.brick_stairs, 2, 3);
		world.setBlock(x + 2, y + 19, z + 24, Blocks.brick_stairs, 0, 3);
		world.setBlock(x + 3, y + 19, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 19, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 19, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 19, z + 24, Blocks.brick_stairs, 1, 3);
		world.setBlock(x + 2, y + 19, z + 25, Blocks.brick_stairs, 0, 3);
		world.setBlock(x + 3, y + 19, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 19, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 19, z + 25, Blocks.brick_stairs, 1, 3);
		world.setBlock(x + 2, y + 19, z + 26, Blocks.brick_stairs, 0, 3);
		world.setBlock(x + 3, y + 19, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 19, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 19, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 6, y + 19, z + 26, Blocks.brick_stairs, 1, 3);
		world.setBlock(x + 3, y + 19, z + 27, Blocks.brick_stairs, 3, 3);
		world.setBlock(x + 4, y + 19, z + 27, Blocks.brick_stairs, 3, 3);
		world.setBlock(x + 5, y + 19, z + 27, Blocks.brick_stairs, 3, 3);
		world.setBlock(x + 3, y + 20, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 20, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 20, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 20, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 20, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 20, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 20, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 20, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 21, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 21, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 21, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 21, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 21, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 21, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 21, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 21, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 22, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 22, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 22, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 22, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 22, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 22, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 22, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 22, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 23, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 23, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 23, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 23, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 23, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 23, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 23, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 23, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 24, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 24, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 24, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 24, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 24, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 24, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 24, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 24, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 25, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 25, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 25, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 25, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 25, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 25, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 25, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 25, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 26, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 26, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 26, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 26, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 26, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 26, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 26, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 26, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 27, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 27, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 27, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 27, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 28, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 28, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 28, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 28, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 29, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 29, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 29, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 29, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 30, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 30, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 30, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 30, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 30, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 30, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 30, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 30, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 31, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 31, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 31, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 31, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 31, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 31, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 31, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 31, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 32, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 32, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 32, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 32, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 32, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 32, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 32, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 32, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 33, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 33, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 33, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 33, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 33, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 33, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 33, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 33, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 34, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 34, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 34, z + 24, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 3, y + 34, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 34, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 34, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 34, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 34, z + 26, Blocks.iron_bars, 0, 3);
		world.setBlock(x + 4, y + 35, z + 24, Blocks.brick_block, 0, 3);
		world.setBlock(x + 3, y + 35, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 5, y + 35, z + 25, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 35, z + 26, Blocks.brick_block, 0, 3);
		world.setBlock(x + 4, y + 36, z + 25, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 37, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 37, z + 23, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 37, z + 24, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 37, z + 24, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 37, z + 25, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 37, z + 25, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 38, z + 20, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 38, z + 20, Blocks.web, 0, 3);
		world.setBlock(x + 7, y + 38, z + 20, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 38, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 38, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 38, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 7, y + 38, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 38, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 38, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 38, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 38, z + 23, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 38, z + 23, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 38, z + 24, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 38, z + 24, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 39, z + 14, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 39, z + 14, Blocks.web, 0, 3);
		world.setBlock(x + 12, y + 39, z + 14, Blocks.web, 0, 3);
		world.setBlock(x + 9, y + 39, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 39, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 39, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 12, y + 39, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 9, y + 39, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 39, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 39, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 12, y + 39, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 9, y + 39, z + 17, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 39, z + 17, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 39, z + 20, Blocks.web, 0, 3);
		world.setBlock(x + 7, y + 39, z + 20, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 39, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 39, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 39, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 4, y + 39, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 39, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 39, z + 22, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 39, z + 23, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 40, z + 14, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 40, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 40, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 12, y + 40, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 40, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 40, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 9, y + 40, z + 17, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 40, z + 17, Blocks.web, 0, 3);
		world.setBlock(x + 5, y + 40, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 6, y + 40, z + 21, Blocks.web, 0, 3);
		world.setBlock(x + 11, y + 41, z + 15, Blocks.web, 0, 3);
		world.setBlock(x + 10, y + 41, z + 16, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 42, z + 9, Blocks.web, 0, 3);
		world.setBlock(x + 18, y + 42, z + 9, Blocks.web, 0, 3);
		world.setBlock(x + 16, y + 42, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 42, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 18, y + 42, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 19, y + 42, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 15, y + 42, z + 11, Blocks.web, 0, 3);
		world.setBlock(x + 16, y + 42, z + 11, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 42, z + 11, Blocks.web, 0, 3);
		world.setBlock(x + 18, y + 42, z + 11, Blocks.web, 0, 3);
		world.setBlock(x + 15, y + 42, z + 12, Blocks.web, 0, 3);
		world.setBlock(x + 16, y + 42, z + 12, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 42, z + 12, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 43, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 18, y + 43, z + 10, Blocks.web, 0, 3);
		world.setBlock(x + 17, y + 43, z + 11, Blocks.web, 0, 3);
		if(GeneralConfig.enableDebugMode)
			System.out.print("[Debug] Successfully spawned abandoned factory at " + x + " " + y +" " + z + "\n");
		return true;

	}

}