//Schematic to java Structure by jajo_11 | inspired by "MITHION'S .SCHEMATIC TO JAVA CONVERTINGTOOL"

package com.hbm.world.dungeon;

import java.util.Random;

import com.hbm.blocks.ModBlocks;
import com.hbm.config.GeneralConfig;
import com.hbm.lib.HbmChestContents;
import com.hbm.lib.Library;
import com.hbm.util.LootGenerator;

import net.minecraft.block.Block;
import net.minecraft.block.material.Material;
import net.minecraft.init.Blocks;
import net.minecraft.tileentity.TileEntityChest;
import net.minecraft.util.WeightedRandomChestContent;
import net.minecraft.world.World;
import net.minecraft.world.gen.feature.WorldGenerator;

public class Satellite extends WorldGenerator
{
	Block dSteel = ModBlocks.deco_steel;
	Block Block3 = ModBlocks.steel_scaffold;
	Block Block4 = ModBlocks.deco_beryllium;
	Block Block5 = ModBlocks.deco_titanium;
	Block dTape = ModBlocks.tape_recorder;
	Block Block7 = ModBlocks.deco_tungsten;
	
	int s2 = 0;
	int s3 = 0;
	int s4 = 8;
	int s5 = 8;
	
	protected Block[] GetValidSpawnBlocks() {
		return new Block[] { Blocks.grass, Blocks.dirt, Blocks.stone, Blocks.sand, Blocks.sandstone };
	}

	public boolean LocationIsValidSpawn(World world, int x, int y, int z) {

		Block checkBlock = world.getBlock(x, y - 1, z);
		Block blockAbove = world.getBlock(x, y, z);
		Block blockBelow = world.getBlock(x, y - 2, z);

		for(Block i : GetValidSpawnBlocks()) {
			if(blockAbove != Blocks.air) {
				return false;
			}
			if(checkBlock == i) {
				return true;
			} else if(checkBlock == Blocks.snow_layer && blockBelow == i) {
				return true;
			} else if(checkBlock.getMaterial() == Material.plants && blockBelow == i) {
				return true;
			}
		}
		return false;
	}

	@Override
	public boolean generate(World world, Random rand, int x, int y, int z) {
		int i = rand.nextInt(1);

		if(i == 0) {
			generate_r0(world, rand, x, y, z);
		}

		return true;
	}

	public boolean generate_r0(World world, Random rand, int x, int y, int z) {
		
		if(!LocationIsValidSpawn(world, x, y, z) || !LocationIsValidSpawn(world, x + 24, y, z) || !LocationIsValidSpawn(world, x + 24, y, z + 30) || !LocationIsValidSpawn(world, x, y, z + 30)) {
			return false;
		}

		world.setBlock(x + 18, y + -3, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -3, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 17, dSteel, 0, 3);
		world.setBlock(x + 8, y + -2, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 17, dSteel, 0, 3);
		world.setBlock(x + 20, y + -2, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 29, dSteel, 0, 3);
		world.setBlock(x + 8, y + -2, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 29, dSteel, 0, 3);
		world.setBlock(x + 20, y + -2, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -2, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + -1, z + 8, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 13, y + -1, z + 8, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 8, dSteel, 0, 3);
		world.setBlock(x + 22, y + -1, z + 8, dSteel, 0, 3);
		world.setBlock(x + 18, y + -1, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 9, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 9, dSteel, 0, 3);
		world.setBlock(x + 22, y + -1, z + 9, dSteel, 0, 3);
		world.setBlock(x + 17, y + -1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 16, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + -1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + -1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + -1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 15, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 16, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 17, dSteel, 0, 3);
		world.setBlock(x + 8, y + -1, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 17, dSteel, 0, 3);
		world.setBlock(x + 20, y + -1, z + 17, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 18, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + -1, z + 23, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 28, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 29, dSteel, 0, 3);
		world.setBlock(x + 8, y + -1, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 29, dSteel, 0, 3);
		world.setBlock(x + 20, y + -1, z + 29, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 6, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 8, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + -1, z + 30, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 0, z + 8, Block3, s3, 3);
		world.setBlock(x + 13, y + 0, z + 8, Block3, s3, 3);
		world.setBlock(x + 19, y + 0, z + 8, dSteel, 0, 3);
		world.setBlock(x + 20, y + 0, z + 8, dSteel, 0, 3);
		world.setBlock(x + 21, y + 0, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 22, y + 0, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 0, z + 9, dSteel, 0, 3);
		world.setBlock(x + 20, y + 0, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 0, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 0, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 0, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 0, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 0, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 0, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 0, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 0, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 0, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 0, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 0, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 0, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 0, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 0, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 0, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 0, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 0, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 0, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 0, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 0, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 0, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 0, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 0, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 0, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 0, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 0, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 1, z + 8, Block3, s3, 3);
		world.setBlock(x + 13, y + 1, z + 8, Block3, s3, 3);
		world.setBlock(x + 17, y + 1, z + 8, dSteel, 0, 3);
		world.setBlock(x + 18, y + 1, z + 8, dSteel, 0, 3);
		world.setBlock(x + 19, y + 1, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 20, y + 1, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 1, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 1, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 1, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 1, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 1, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 1, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 1, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 1, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 1, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 1, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 1, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 1, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 1, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 2, z + 8, Block3, s3, 3);
		world.setBlock(x + 13, y + 2, z + 8, Block3, s3, 3);
		world.setBlock(x + 15, y + 2, z + 8, dSteel, 0, 3);
		world.setBlock(x + 16, y + 2, z + 8, dSteel, 0, 3);
		world.setBlock(x + 17, y + 2, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 2, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 2, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 2, z + 9, dSteel, 0, 3);
		world.setBlock(x + 16, y + 2, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 2, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 2, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 2, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 2, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 2, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 2, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 2, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 2, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 2, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 2, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 3, z + 8, Block3, s3, 3);
		world.setBlock(x + 13, y + 3, z + 8, dSteel, 0, 3);
		world.setBlock(x + 14, y + 3, z + 8, dSteel, 0, 3);
		world.setBlock(x + 15, y + 3, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 16, y + 3, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 3, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 13, y + 3, z + 9, dSteel, 0, 3);
		world.setBlock(x + 14, y + 3, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 3, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 3, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 3, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 3, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 3, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 3, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 3, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 3, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 3, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 3, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 4, z + 8, Block3, s3, 3);
		world.setBlock(x + 11, y + 4, z + 8, dSteel, 0, 3);
		world.setBlock(x + 12, y + 4, z + 8, dSteel, 0, 3);
		world.setBlock(x + 13, y + 4, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 14, y + 4, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 4, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 11, y + 4, z + 9, dSteel, 0, 3);
		world.setBlock(x + 12, y + 4, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 4, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 4, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 4, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 4, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 4, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 4, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 4, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 4, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 4, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 4, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 4, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 4, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 4, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 4, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 4, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 4, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 4, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 4, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 4, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 4, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 4, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 4, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 4, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 4, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 4, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 4, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 5, z + 8, Block3, s3, 3);
		world.setBlock(x + 9, y + 5, z + 8, dSteel, 0, 3);
		world.setBlock(x + 10, y + 5, z + 8, dSteel, 0, 3);
		world.setBlock(x + 11, y + 5, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 12, y + 5, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 13, y + 5, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 9, y + 5, z + 9, dSteel, 0, 3);
		world.setBlock(x + 10, y + 5, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 5, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 5, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 5, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 5, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 5, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 5, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 5, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 5, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 5, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 5, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 5, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 5, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 5, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 5, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 5, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 5, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 5, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 5, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 5, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 5, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 5, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 5, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 5, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 5, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 5, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 5, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 6, z + 8, Block3, s3, 3);
		world.setBlock(x + 7, y + 6, z + 8, dSteel, 0, 3);
		world.setBlock(x + 8, y + 6, z + 8, dSteel, 0, 3);
		world.setBlock(x + 9, y + 6, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 10, y + 6, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 11, y + 6, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 6, z + 9, dSteel, 0, 3);
		world.setBlock(x + 8, y + 6, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 6, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 6, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 6, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 6, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 6, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 6, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 6, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 6, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 6, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 6, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 6, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 6, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 6, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 6, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 6, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 6, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 6, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 6, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 6, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 6, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 6, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 6, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 6, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 6, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 6, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 6, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 7, z + 8, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 8, dSteel, 0, 3);
		world.setBlock(x + 7, y + 7, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 8, y + 7, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 9, y + 7, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 7, z + 9, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 9, dSteel, 0, 3);
		world.setBlock(x + 5, y + 7, z + 10, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 7, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 7, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 7, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 7, z + 11, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 11, dSteel, 0, 3);
		world.setBlock(x + 17, y + 7, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 7, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 7, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 7, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 7, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 7, z + 12, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 12, dSteel, 0, 3);
		world.setBlock(x + 17, y + 7, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 7, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 7, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 7, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 7, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 7, z + 13, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 13, dSteel, 0, 3);
		world.setBlock(x + 17, y + 7, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 7, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 7, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 7, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 7, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 7, z + 14, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 7, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 7, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 7, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 7, z + 15, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 15, dSteel, 0, 3);
		world.setBlock(x + 5, y + 7, z + 16, dSteel, 0, 3);
		world.setBlock(x + 6, y + 7, z + 16, dSteel, 0, 3);
		world.setBlock(x + 7, y + 7, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 7, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 7, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 7, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 7, z + 29, Block4, 0, 3);
		world.setBlock(x + 5, y + 8, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 6, y + 8, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 8, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 8, z + 9, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 8, z + 10, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 8, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 8, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 8, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 8, z + 11, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 8, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 8, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 8, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 8, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 8, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 8, z + 12, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 8, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 8, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 8, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 8, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 8, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 8, z + 13, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 8, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 8, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 8, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 8, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 8, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 8, z + 14, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 8, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 8, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 8, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 8, z + 15, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 8, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 8, z + 17, dSteel, 0, 3);
		world.setBlock(x + 6, y + 8, z + 17, dSteel, 0, 3);
		world.setBlock(x + 7, y + 8, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 8, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 8, z + 18, dSteel, 0, 3);
		world.setBlock(x + 6, y + 8, z + 18, dSteel, 0, 3);
		world.setBlock(x + 5, y + 8, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 8, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 8, z + 29, Block4, 0, 3);
		world.setBlock(x + 18, y + 9, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 9, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 9, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 9, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 9, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 9, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 9, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 9, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 9, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 9, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 9, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 9, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 9, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 9, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 9, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 9, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 9, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 9, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 9, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 9, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 9, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 5, y + 9, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 9, z + 17, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 9, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 9, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 9, z + 18, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 9, z + 19, dSteel, 0, 3);
		world.setBlock(x + 6, y + 9, z + 19, dSteel, 0, 3);
		world.setBlock(x + 5, y + 9, z + 20, dSteel, 0, 3);
		world.setBlock(x + 6, y + 9, z + 20, dSteel, 0, 3);
		world.setBlock(x + 5, y + 9, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 9, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 9, z + 29, Block4, 0, 3);
		world.setBlock(x + 18, y + 10, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 10, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 10, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 10, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 10, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 10, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 10, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 10, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 10, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 10, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 10, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 10, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 10, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 10, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 10, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 10, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 10, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 10, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 10, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 10, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 10, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 10, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 10, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 10, z + 18, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 10, z + 19, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 10, z + 20, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 10, z + 21, dSteel, 0, 3);
		world.setBlock(x + 6, y + 10, z + 21, dSteel, 0, 3);
		world.setBlock(x + 5, y + 10, z + 22, dSteel, 0, 3);
		world.setBlock(x + 6, y + 10, z + 22, dSteel, 0, 3);
		world.setBlock(x + 5, y + 10, z + 23, Block3, s5, 3);
		world.setBlock(x + 7, y + 10, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 10, z + 29, Block4, 0, 3);
		world.setBlock(x + 18, y + 11, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 11, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 11, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 11, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 11, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 11, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 11, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 11, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 11, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 11, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 11, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 11, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 11, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 11, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 11, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 11, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 11, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 11, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 11, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 11, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 11, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 11, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 11, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 11, z + 20, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 11, z + 21, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 11, z + 22, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 11, z + 23, dSteel, 0, 3);
		world.setBlock(x + 6, y + 11, z + 23, dSteel, 0, 3);
		world.setBlock(x + 5, y + 11, z + 24, dSteel, 0, 3);
		world.setBlock(x + 6, y + 11, z + 24, dSteel, 0, 3);
		world.setBlock(x + 7, y + 11, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 11, z + 29, Block4, 0, 3);
		world.setBlock(x + 18, y + 12, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 12, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 12, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 12, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 12, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 12, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 12, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 12, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 12, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 12, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 12, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 12, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 12, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 12, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 12, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 12, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 12, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 12, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 12, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 12, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 12, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 12, z + 17, Block4, 0, 3);
		world.setBlock(x + 19, y + 12, z + 17, Block4, 0, 3);
		world.setBlock(x + 5, y + 12, z + 22, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 12, z + 23, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 12, z + 24, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 5, y + 12, z + 25, dSteel, 0, 3);
		world.setBlock(x + 6, y + 12, z + 25, dSteel, 0, 3);
		world.setBlock(x + 5, y + 12, z + 26, dSteel, 0, 3);
		world.setBlock(x + 6, y + 12, z + 26, dSteel, 0, 3);
		world.setBlock(x + 7, y + 12, z + 29, Block4, 0, 3);
		world.setBlock(x + 19, y + 12, z + 29, Block4, 0, 3);
		world.setBlock(x + 18, y + 13, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 13, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 13, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 13, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 13, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 13, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 13, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 13, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 13, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 13, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 13, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 13, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 13, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 13, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 13, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 13, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 13, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 13, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 13, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 13, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 13, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 13, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 13, z + 17, Block5, 0, 3);
		world.setBlock(x + 7, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 9, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 10, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 11, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 12, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 13, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 15, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 16, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 19, y + 13, z + 18, Block5, 0, 3);
		world.setBlock(x + 7, y + 13, z + 19, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 19, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 19, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 19, Block5, 0, 3);
		world.setBlock(x + 7, y + 13, z + 20, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 20, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 20, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 20, Block5, 0, 3);
		world.setBlock(x + 20, y + 13, z + 20, dSteel, 0, 3);
		world.setBlock(x + 21, y + 13, z + 20, dSteel, 0, 3);
		world.setBlock(x + 7, y + 13, z + 21, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 21, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 21, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 21, Block5, 0, 3);
		world.setBlock(x + 20, y + 13, z + 21, dSteel, 0, 3);
		world.setBlock(x + 21, y + 13, z + 21, dSteel, 0, 3);
		world.setBlock(x + 7, y + 13, z + 22, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 22, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 22, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 22, Block5, 0, 3);
		world.setBlock(x + 20, y + 13, z + 22, dSteel, 0, 3);
		world.setBlock(x + 21, y + 13, z + 22, dSteel, 0, 3);
		world.setBlock(x + 7, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 9, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 10, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 11, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 12, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 15, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 16, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 17, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 18, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 19, y + 13, z + 23, Block5, 0, 3);
		world.setBlock(x + 5, y + 13, z + 24, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 13, z + 24, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 24, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 24, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 24, Block5, 0, 3);
		world.setBlock(x + 5, y + 13, z + 25, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 13, z + 25, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 25, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 25, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 25, Block5, 0, 3);
		world.setBlock(x + 5, y + 13, z + 26, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 13, z + 26, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 26, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 26, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 26, Block5, 0, 3);
		world.setBlock(x + 5, y + 13, z + 27, dSteel, 0, 3);
		world.setBlock(x + 6, y + 13, z + 27, dSteel, 0, 3);
		world.setBlock(x + 7, y + 13, z + 27, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 9, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 10, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 11, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 12, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 13, y + 13, z + 27, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 15, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 16, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 17, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 18, y + 13, z + 27, Blocks.stone_slab, 8, 3);
		world.setBlock(x + 19, y + 13, z + 27, Block5, 0, 3);
		world.setBlock(x + 5, y + 13, z + 28, dSteel, 0, 3);
		world.setBlock(x + 6, y + 13, z + 28, dSteel, 0, 3);
		world.setBlock(x + 7, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 8, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 9, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 10, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 11, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 12, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 13, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 14, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 15, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 16, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 17, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 18, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 19, y + 13, z + 28, Block5, 0, 3);
		world.setBlock(x + 7, y + 13, z + 29, Block5, 0, 3);
		world.setBlock(x + 19, y + 13, z + 29, Block5, 0, 3);
		world.setBlock(x + 18, y + 14, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 14, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 14, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 14, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 14, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 14, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 14, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 14, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 14, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 14, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 14, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 14, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 14, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 14, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 14, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 14, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 14, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 14, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 14, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 14, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 14, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 8, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 9, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 10, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 11, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 12, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 13, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 14, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 15, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 16, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 17, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 18, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 18, dSteel, 0, 3);
		world.setBlock(x + 7, y + 14, z + 19, dSteel, 0, 3);
		world.setBlock(x + 10, y + 14, z + 19, Blocks.chest, 3, 3);
		world.setBlockMetadataWithNotify(x + 10, y + 14, z + 19, 3, 3);
        WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.modGeneric, (TileEntityChest)world.getTileEntity(x + 10, y + 14, z + 19), 8);
		world.setBlock(x + 19, y + 14, z + 19, dSteel, 0, 3);
		world.setBlock(x + 20, y + 14, z + 19, dSteel, 0, 3);
		world.setBlock(x + 21, y + 14, z + 19, dSteel, 0, 3);
		world.setBlock(x + 7, y + 14, z + 20, dSteel, 0, 3);
		world.setBlock(x + 21, y + 14, z + 20, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 14, z + 21, dSteel, 0, 3);
		world.setBlock(x + 21, y + 14, z + 21, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 14, z + 22, dSteel, 0, 3);
		world.setBlock(x + 13, y + 14, z + 22, dSteel, 0, 3);
		world.setBlock(x + 14, y + 14, z + 22, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 22, dSteel, 0, 3);
		world.setBlock(x + 20, y + 14, z + 22, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 14, z + 22, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 14, z + 23, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 13, y + 14, z + 23, dSteel, 0, 3);
		world.setBlock(x + 14, y + 14, z + 23, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 23, dSteel, 0, 3);
		world.setBlock(x + 7, y + 14, z + 24, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 13, y + 14, z + 24, dSteel, 0, 3);
		world.setBlock(x + 14, y + 14, z + 24, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 24, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 25, dSteel, 0, 3);
		world.setBlock(x + 5, y + 14, z + 26, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 14, z + 26, dSteel, 0, 3);
		world.setBlock(x + 5, y + 14, z + 27, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 14, z + 27, dSteel, 0, 3);
		world.setBlock(x + 16, y + 14, z + 27, Blocks.chest, 2, 3);
		world.setBlockMetadataWithNotify(x + 16, y + 14, z + 27, 3, 3);
        WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.antenna, (TileEntityChest)world.getTileEntity(x + 16, y + 14, z + 27), 8);
		world.setBlock(x + 19, y + 14, z + 27, dSteel, 0, 3);
		world.setBlock(x + 5, y + 14, z + 28, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 6, y + 14, z + 28, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 8, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 9, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 10, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 11, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 12, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 13, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 14, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 15, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 16, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 17, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 18, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 19, y + 14, z + 28, dSteel, 0, 3);
		world.setBlock(x + 18, y + 15, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 15, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 15, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 15, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 15, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 15, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 15, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 15, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 15, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 15, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 15, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 15, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 15, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 15, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 15, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 15, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 15, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 15, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 15, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 15, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 15, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 7, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 8, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 9, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 10, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 11, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 12, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 13, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 14, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 15, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 16, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 17, y + 15, z + 18, Block4, 0, 3);
		world.setBlock(x + 18, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 20, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 21, y + 15, z + 18, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 19, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 19, dSteel, 0, 3);
		world.setBlock(x + 21, y + 15, z + 19, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 15, z + 20, dSteel, 0, 3);
		world.setBlock(x + 21, y + 15, z + 20, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 15, z + 21, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 22, dSteel, 0, 3);
		world.setBlock(x + 14, y + 15, z + 22, dTape, 4, 3);
		world.setBlock(x + 19, y + 15, z + 22, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 23, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 14, y + 15, z + 23, dTape, 4, 3);
		world.setBlock(x + 19, y + 15, z + 23, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 24, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 14, y + 15, z + 24, Block3, s5, 3);
		world.setBlock(x + 19, y + 15, z + 24, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 25, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 26, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 27, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 27, dSteel, 0, 3);
		world.setBlock(x + 7, y + 15, z + 28, dSteel, 0, 3);
		world.setBlock(x + 8, y + 15, z + 28, dSteel, 0, 3);
		world.setBlock(x + 9, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 10, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 11, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 12, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 13, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 14, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 15, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 16, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 17, y + 15, z + 28, Block4, 0, 3);
		world.setBlock(x + 18, y + 15, z + 28, dSteel, 0, 3);
		world.setBlock(x + 19, y + 15, z + 28, dSteel, 0, 3);
		world.setBlock(x + 18, y + 16, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 16, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 16, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 16, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 16, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 16, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 16, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 16, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 16, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 16, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 16, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 16, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 16, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 16, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 16, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 16, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 16, z + 17, dSteel, 0, 3);
		world.setBlock(x + 20, y + 16, z + 17, dSteel, 0, 3);
		world.setBlock(x + 21, y + 16, z + 17, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 8, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 9, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 10, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 11, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 12, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 13, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 14, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 15, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 16, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 17, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 18, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 18, dSteel, 0, 3);
		world.setBlock(x + 21, y + 16, z + 18, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 16, z + 19, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 19, dSteel, 0, 3);
		world.setBlock(x + 21, y + 16, z + 19, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 16, z + 20, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 20, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 21, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 21, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 22, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 22, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 23, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 16, z + 23, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 24, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 14, y + 16, z + 24, Block3, s5, 3);
		world.setBlock(x + 19, y + 16, z + 24, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 25, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 26, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 27, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 27, dSteel, 0, 3);
		world.setBlock(x + 7, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 8, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 9, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 10, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 11, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 12, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 13, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 14, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 15, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 16, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 17, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 18, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 19, y + 16, z + 28, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 20, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 21, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 8, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 20, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 21, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 9, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 17, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 17, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 10, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 11, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 11, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 17, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 17, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 17, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 17, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + 17, z + 11, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 11, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 12, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 12, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 17, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 17, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 17, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 17, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + 17, z + 12, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 12, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 13, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 13, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 17, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 17, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 17, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 17, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 22, y + 17, z + 13, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 13, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 17, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 17, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 14, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 20, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 21, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 23, y + 17, z + 15, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 20, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 21, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 22, y + 17, z + 16, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 17, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 17, z + 17, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 17, z + 18, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 17, z + 18, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 7, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 19, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 20, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 21, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 22, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 23, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 24, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 25, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 26, dSteel, 0, 3);
		world.setBlock(x + 7, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 8, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 9, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 10, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 11, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 12, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 13, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 14, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 15, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 16, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 17, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 18, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 19, y + 17, z + 27, dSteel, 0, 3);
		world.setBlock(x + 16, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 20, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 22, y + 18, z + 8, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 9, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 16, y + 18, z + 9, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 22, y + 18, z + 9, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 23, y + 18, z + 9, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 10, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 18, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 18, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 18, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 23, y + 18, z + 10, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 11, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 18, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 18, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 18, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 18, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 18, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 23, y + 18, z + 11, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 12, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 18, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 18, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 18, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 18, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 18, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 23, y + 18, z + 12, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 13, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 18, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 18, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 18, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 18, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 18, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 23, y + 18, z + 13, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 14, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 18, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 18, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 18, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 23, y + 18, z + 14, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 15, y + 18, z + 15, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 16, y + 18, z + 15, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 22, y + 18, z + 15, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 23, y + 18, z + 15, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 16, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 17, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 22, y + 18, z + 16, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 19, y + 18, z + 17, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 21, y + 18, z + 17, ModBlocks.fence_metal, 0, 3);
		world.setBlock(x + 18, y + 19, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 19, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 19, z + 10, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 19, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 19, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 19, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 19, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 19, z + 11, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 19, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 19, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 19, z + 12, Blocks.chest, 4, 3);
		world.setBlockMetadataWithNotify(x + 19, y + 19, z + 12, 4, 3);
        WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.expensive, (TileEntityChest)world.getTileEntity(x + 19, y + 19, z + 12), 12);
		world.setBlock(x + 20, y + 19, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 19, z + 12, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 17, y + 19, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 19, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 19, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 19, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 21, y + 19, z + 13, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 19, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 19, y + 19, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 20, y + 19, z + 14, Library.getRandomConcrete(), 0, 3);
		world.setBlock(x + 18, y + 20, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 20, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 20, z + 10, dSteel, 0, 3);
		world.setBlock(x + 17, y + 20, z + 11, dSteel, 0, 3);
		world.setBlock(x + 18, y + 20, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 20, z + 11, dSteel, 0, 3);
		world.setBlock(x + 20, y + 20, z + 11, dSteel, 0, 3);
		world.setBlock(x + 21, y + 20, z + 11, dSteel, 0, 3);
		world.setBlock(x + 17, y + 20, z + 12, dSteel, 0, 3);
		world.setBlock(x + 18, y + 20, z + 12, dSteel, 0, 3);
		world.setBlock(x + 19, y + 20, z + 12, dSteel, 0, 3);
		world.setBlock(x + 20, y + 20, z + 12, dSteel, 0, 3);
		world.setBlock(x + 21, y + 20, z + 12, Block5, 0, 3);
		world.setBlock(x + 22, y + 20, z + 12, Block5, 0, 3);
		world.setBlock(x + 23, y + 20, z + 12, Block5, 0, 3);
		world.setBlock(x + 17, y + 20, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 20, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 20, z + 13, dSteel, 0, 3);
		world.setBlock(x + 20, y + 20, z + 13, dSteel, 0, 3);
		world.setBlock(x + 21, y + 20, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 20, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 20, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 20, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 21, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 21, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 21, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 21, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 21, z + 11, dSteel, 0, 3);
		world.setBlock(x + 20, y + 21, z + 11, dSteel, 0, 3);
		world.setBlock(x + 22, y + 21, z + 11, Block4, 0, 3);
		world.setBlock(x + 21, y + 21, z + 12, Block5, 0, 3);
		world.setBlock(x + 22, y + 21, z + 12, Block4, 0, 3);
		world.setBlock(x + 23, y + 21, z + 12, Block5, 0, 3);
		world.setBlock(x + 24, y + 21, z + 12, Block5, 0, 3);
		world.setBlock(x + 18, y + 21, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 21, z + 13, dSteel, 0, 3);
		world.setBlock(x + 20, y + 21, z + 13, dSteel, 0, 3);
		world.setBlock(x + 22, y + 21, z + 13, Block4, 0, 3);
		world.setBlock(x + 18, y + 21, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 21, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 21, z + 14, dSteel, 0, 3);
		world.setBlock(x + 15, y + 22, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 22, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 22, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 22, z + 10, dSteel, 0, 3);
		world.setBlock(x + 21, y + 22, z + 11, Block4, 0, 3);
		world.setBlock(x + 22, y + 22, z + 11, Block4, 0, 3);
		world.setBlock(x + 23, y + 22, z + 11, Block4, 0, 3);
		world.setBlock(x + 21, y + 22, z + 12, Block4, 0, 3);
		world.setBlock(x + 22, y + 22, z + 12, Block4, 0, 3);
		world.setBlock(x + 23, y + 22, z + 12, Block4, 0, 3);
		world.setBlock(x + 24, y + 22, z + 12, Block5, 0, 3);
		world.setBlock(x + 21, y + 22, z + 13, Block4, 0, 3);
		world.setBlock(x + 22, y + 22, z + 13, Block4, 0, 3);
		world.setBlock(x + 23, y + 22, z + 13, Block4, 0, 3);
		world.setBlock(x + 18, y + 22, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 22, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 22, z + 14, dSteel, 0, 3);
		world.setBlock(x + 15, y + 22, z + 15, dSteel, 0, 3);
		world.setBlock(x + 14, y + 23, z + 9, dSteel, 0, 3);
		world.setBlock(x + 15, y + 23, z + 9, dSteel, 0, 3);
		world.setBlock(x + 16, y + 23, z + 9, dSteel, 0, 3);
		world.setBlock(x + 15, y + 23, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 23, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 23, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 23, z + 10, dSteel, 0, 3);
		world.setBlock(x + 15, y + 23, z + 11, dSteel, 0, 3);
		world.setBlock(x + 20, y + 23, z + 11, Block4, 0, 3);
		world.setBlock(x + 21, y + 23, z + 11, Block4, 0, 3);
		world.setBlock(x + 22, y + 23, z + 11, Block4, 0, 3);
		world.setBlock(x + 15, y + 23, z + 12, dSteel, 0, 3);
		world.setBlock(x + 20, y + 23, z + 12, Block4, 0, 3);
		world.setBlock(x + 21, y + 23, z + 12, Block4, 0, 3);
		world.setBlock(x + 22, y + 23, z + 12, Block4, 0, 3);
		world.setBlock(x + 23, y + 23, z + 12, Block5, 0, 3);
		world.setBlock(x + 24, y + 23, z + 12, Block5, 0, 3);
		world.setBlock(x + 15, y + 23, z + 13, dSteel, 0, 3);
		world.setBlock(x + 20, y + 23, z + 13, Block4, 0, 3);
		world.setBlock(x + 21, y + 23, z + 13, Block4, 0, 3);
		world.setBlock(x + 22, y + 23, z + 13, Block4, 0, 3);
		world.setBlock(x + 15, y + 23, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 23, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 23, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 23, z + 14, dSteel, 0, 3);
		world.setBlock(x + 14, y + 23, z + 15, dSteel, 0, 3);
		world.setBlock(x + 15, y + 23, z + 15, dSteel, 0, 3);
		world.setBlock(x + 16, y + 23, z + 15, dSteel, 0, 3);
		world.setBlock(x + 5, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 9, Block5, 0, 3);
		world.setBlock(x + 15, y + 24, z + 9, dSteel, 0, 3);
		world.setBlock(x + 16, y + 24, z + 9, dSteel, 0, 3);
		world.setBlock(x + 17, y + 24, z + 9, dSteel, 0, 3);
		world.setBlock(x + 5, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 10, Block5, 0, 3);
		world.setBlock(x + 12, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 13, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 14, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 15, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 16, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 17, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 24, z + 10, dSteel, 0, 3);
		world.setBlock(x + 5, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 11, Block5, 0, 3);
		world.setBlock(x + 17, y + 24, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 24, z + 11, Block4, 0, 3);
		world.setBlock(x + 20, y + 24, z + 11, Block4, 0, 3);
		world.setBlock(x + 21, y + 24, z + 11, Block4, 0, 3);
		world.setBlock(x + 5, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 12, Block5, 0, 3);
		world.setBlock(x + 17, y + 24, z + 12, dSteel, 0, 3);
		world.setBlock(x + 19, y + 24, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 24, z + 12, Block4, 0, 3);
		world.setBlock(x + 21, y + 24, z + 12, Block4, 0, 3);
		world.setBlock(x + 5, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 13, Block5, 0, 3);

		generate_r02(world, rand, x, y, z);
		return true;

	}
	public boolean generate_r02(World world, Random rand, int x, int y, int z)
	{

		world.setBlock(x + 7, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 13, Block5, 0, 3);
		world.setBlock(x + 17, y + 24, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 24, z + 13, Block4, 0, 3);
		world.setBlock(x + 20, y + 24, z + 13, Block4, 0, 3);
		world.setBlock(x + 21, y + 24, z + 13, Block4, 0, 3);
		world.setBlock(x + 5, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 14, Block5, 0, 3);
		world.setBlock(x + 12, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 13, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 14, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 15, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 16, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 17, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 24, z + 14, dSteel, 0, 3);
		world.setBlock(x + 5, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 6, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 7, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 8, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 9, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 10, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 11, y + 24, z + 15, Block5, 0, 3);
		world.setBlock(x + 15, y + 24, z + 15, dSteel, 0, 3);
		world.setBlock(x + 16, y + 24, z + 15, dSteel, 0, 3);
		world.setBlock(x + 17, y + 24, z + 15, dSteel, 0, 3);
		world.setBlock(x + 5, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 6, Block5, 0, 3);
		world.setBlock(x + 5, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 7, Block5, 0, 3);
		world.setBlock(x + 5, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 8, Block5, 0, 3);
		world.setBlock(x + 2, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 9, Block5, 0, 3);
		world.setBlock(x + 16, y + 25, z + 9, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 9, dSteel, 0, 3);
		world.setBlock(x + 2, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 10, Block5, 0, 3);
		world.setBlock(x + 15, y + 25, z + 10, dSteel, 0, 3);
		world.setBlock(x + 16, y + 25, z + 10, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 25, z + 10, dSteel, 0, 3);
		world.setBlock(x + 2, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 11, Block5, 0, 3);
		world.setBlock(x + 16, y + 25, z + 11, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 11, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 25, z + 11, Block4, 0, 3);
		world.setBlock(x + 20, y + 25, z + 11, Block4, 0, 3);
		world.setBlock(x + 2, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 12, Block4, 0, 3);
		world.setBlock(x + 12, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 12, Block5, 0, 3);
		world.setBlock(x + 16, y + 25, z + 12, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 12, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 12, dSteel, 0, 3);
		world.setBlock(x + 19, y + 25, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 25, z + 12, Block4, 0, 3);
		world.setBlock(x + 2, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 13, Block5, 0, 3);
		world.setBlock(x + 16, y + 25, z + 13, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 25, z + 13, Block4, 0, 3);
		world.setBlock(x + 20, y + 25, z + 13, Block4, 0, 3);
		world.setBlock(x + 2, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 14, Block5, 0, 3);
		world.setBlock(x + 15, y + 25, z + 14, dSteel, 0, 3);
		world.setBlock(x + 16, y + 25, z + 14, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 25, z + 14, dSteel, 0, 3);
		world.setBlock(x + 2, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 3, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 4, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 12, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 13, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 14, y + 25, z + 15, Block5, 0, 3);
		world.setBlock(x + 16, y + 25, z + 15, dSteel, 0, 3);
		world.setBlock(x + 17, y + 25, z + 15, dSteel, 0, 3);
		world.setBlock(x + 18, y + 25, z + 15, dSteel, 0, 3);
		world.setBlock(x + 5, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 16, Block5, 0, 3);
		world.setBlock(x + 5, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 17, Block5, 0, 3);
		world.setBlock(x + 5, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 6, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 7, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 8, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 9, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 10, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 11, y + 25, z + 18, Block5, 0, 3);
		world.setBlock(x + 5, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 6, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 7, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 8, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 9, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 10, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 11, y + 26, z + 4, Block5, 0, 3);
		world.setBlock(x + 5, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 6, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 7, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 8, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 9, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 10, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 11, y + 26, z + 5, Block5, 0, 3);
		world.setBlock(x + 2, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 6, Block5, 0, 3);
		world.setBlock(x + 2, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 7, Block5, 0, 3);
		world.setBlock(x + 2, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 8, Block5, 0, 3);
		world.setBlock(x + 0, y + 26, z + 9, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 9, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 9, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 9, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 9, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 9, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 10, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 10, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 10, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 10, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 10, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 11, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 11, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 11, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 11, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 11, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 11, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 12, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 12, Block5, 0, 3);
		world.setBlock(x + 10, y + 26, z + 12, Block4, 0, 3);
		world.setBlock(x + 11, y + 26, z + 12, Block4, 0, 3);
		world.setBlock(x + 15, y + 26, z + 12, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 12, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 12, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 12, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 12, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 13, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 13, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 13, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 13, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 13, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 14, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 14, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 14, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 14, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 14, dSteel, 0, 3);
		world.setBlock(x + 0, y + 26, z + 15, Block7, 0, 3);
		world.setBlock(x + 1, y + 26, z + 15, Block5, 0, 3);
		world.setBlock(x + 15, y + 26, z + 15, Block5, 0, 3);
		world.setBlock(x + 16, y + 26, z + 15, Block5, 0, 3);
		world.setBlock(x + 17, y + 26, z + 15, dSteel, 0, 3);
		world.setBlock(x + 18, y + 26, z + 15, dSteel, 0, 3);
		world.setBlock(x + 19, y + 26, z + 15, dSteel, 0, 3);
		world.setBlock(x + 2, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 16, Block5, 0, 3);
		world.setBlock(x + 2, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 17, Block5, 0, 3);
		world.setBlock(x + 2, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 3, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 4, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 12, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 13, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 14, y + 26, z + 18, Block5, 0, 3);
		world.setBlock(x + 5, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 6, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 7, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 8, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 9, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 10, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 11, y + 26, z + 19, Block5, 0, 3);
		world.setBlock(x + 5, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 6, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 7, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 8, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 9, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 10, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 11, y + 26, z + 20, Block5, 0, 3);
		world.setBlock(x + 5, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 6, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 7, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 8, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 9, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 10, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 11, y + 27, z + 3, Block5, 0, 3);
		world.setBlock(x + 2, y + 27, z + 4, Block7, 0, 3);
		world.setBlock(x + 3, y + 27, z + 4, Block5, 0, 3);
		world.setBlock(x + 4, y + 27, z + 4, Block5, 0, 3);
		world.setBlock(x + 12, y + 27, z + 4, Block5, 0, 3);
		world.setBlock(x + 13, y + 27, z + 4, Block5, 0, 3);
		world.setBlock(x + 14, y + 27, z + 4, Block5, 0, 3);
		world.setBlock(x + 2, y + 27, z + 5, Block7, 0, 3);
		world.setBlock(x + 3, y + 27, z + 5, Block5, 0, 3);
		world.setBlock(x + 4, y + 27, z + 5, Block5, 0, 3);
		world.setBlock(x + 12, y + 27, z + 5, Block5, 0, 3);
		world.setBlock(x + 13, y + 27, z + 5, Block5, 0, 3);
		world.setBlock(x + 14, y + 27, z + 5, Block5, 0, 3);
		world.setBlock(x + 1, y + 27, z + 6, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 6, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 6, Block5, 0, 3);
		world.setBlock(x + 1, y + 27, z + 7, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 7, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 7, Block5, 0, 3);
		world.setBlock(x + 1, y + 27, z + 8, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 8, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 8, Block5, 0, 3);
		world.setBlock(x + 17, y + 27, z + 9, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 9, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 9, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 9, dSteel, 0, 3);
		world.setBlock(x + 17, y + 27, z + 10, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 10, dSteel, 0, 3);
		world.setBlock(x + 17, y + 27, z + 11, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 11, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 11, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 11, dSteel, 0, 3);
		world.setBlock(x + 10, y + 27, z + 12, Block4, 0, 3);
		world.setBlock(x + 17, y + 27, z + 12, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 12, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 12, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 12, dSteel, 0, 3);
		world.setBlock(x + 17, y + 27, z + 13, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 13, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 13, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 13, dSteel, 0, 3);
		world.setBlock(x + 17, y + 27, z + 14, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 14, dSteel, 0, 3);
		world.setBlock(x + 17, y + 27, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 27, z + 15, dSteel, 0, 3);
		world.setBlock(x + 19, y + 27, z + 15, dSteel, 0, 3);
		world.setBlock(x + 20, y + 27, z + 15, dSteel, 0, 3);
		world.setBlock(x + 1, y + 27, z + 16, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 16, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 16, Block5, 0, 3);
		world.setBlock(x + 1, y + 27, z + 17, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 17, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 17, Block5, 0, 3);
		world.setBlock(x + 1, y + 27, z + 18, Block7, 0, 3);
		world.setBlock(x + 15, y + 27, z + 18, Block5, 0, 3);
		world.setBlock(x + 16, y + 27, z + 18, Block5, 0, 3);
		world.setBlock(x + 2, y + 27, z + 19, Block7, 0, 3);
		world.setBlock(x + 3, y + 27, z + 19, Block5, 0, 3);
		world.setBlock(x + 4, y + 27, z + 19, Block5, 0, 3);
		world.setBlock(x + 12, y + 27, z + 19, Block5, 0, 3);
		world.setBlock(x + 13, y + 27, z + 19, Block5, 0, 3);
		world.setBlock(x + 14, y + 27, z + 19, Block5, 0, 3);
		world.setBlock(x + 2, y + 27, z + 20, Block7, 0, 3);
		world.setBlock(x + 3, y + 27, z + 20, Block5, 0, 3);
		world.setBlock(x + 4, y + 27, z + 20, Block5, 0, 3);
		world.setBlock(x + 12, y + 27, z + 20, Block5, 0, 3);
		world.setBlock(x + 13, y + 27, z + 20, Block5, 0, 3);
		world.setBlock(x + 14, y + 27, z + 20, Block5, 0, 3);
		world.setBlock(x + 5, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 6, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 7, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 8, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 9, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 10, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 11, y + 27, z + 21, Block5, 0, 3);
		world.setBlock(x + 5, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 6, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 7, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 8, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 9, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 10, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 11, y + 28, z + 2, Block5, 0, 3);
		world.setBlock(x + 2, y + 28, z + 3, Block7, 0, 3);
		world.setBlock(x + 3, y + 28, z + 3, Block5, 0, 3);
		world.setBlock(x + 4, y + 28, z + 3, Block5, 0, 3);
		world.setBlock(x + 12, y + 28, z + 3, Block5, 0, 3);
		world.setBlock(x + 13, y + 28, z + 3, Block5, 0, 3);
		world.setBlock(x + 14, y + 28, z + 3, Block5, 0, 3);
		world.setBlock(x + 15, y + 28, z + 4, Block5, 0, 3);
		world.setBlock(x + 16, y + 28, z + 4, Block5, 0, 3);
		world.setBlock(x + 15, y + 28, z + 5, Block5, 0, 3);
		world.setBlock(x + 16, y + 28, z + 5, Block5, 0, 3);
		world.setBlock(x + 17, y + 28, z + 6, Block5, 0, 3);
		world.setBlock(x + 17, y + 28, z + 7, Block5, 0, 3);
		world.setBlock(x + 17, y + 28, z + 8, Block5, 0, 3);
		world.setBlock(x + 18, y + 28, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 9, dSteel, 0, 3);
		world.setBlock(x + 20, y + 28, z + 9, dSteel, 0, 3);
		world.setBlock(x + 21, y + 28, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 28, z + 10, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 28, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 28, z + 11, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 11, dSteel, 0, 3);
		world.setBlock(x + 9, y + 28, z + 12, Block4, 0, 3);
		world.setBlock(x + 10, y + 28, z + 12, Block4, 0, 3);
		world.setBlock(x + 18, y + 28, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 12, dSteel, 0, 3);
		world.setBlock(x + 18, y + 28, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 28, z + 14, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 28, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 28, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 28, z + 15, dSteel, 0, 3);
		world.setBlock(x + 20, y + 28, z + 15, dSteel, 0, 3);
		world.setBlock(x + 21, y + 28, z + 15, dSteel, 0, 3);
		world.setBlock(x + 17, y + 28, z + 16, Block5, 0, 3);
		world.setBlock(x + 17, y + 28, z + 17, Block5, 0, 3);
		world.setBlock(x + 17, y + 28, z + 18, Block5, 0, 3);
		world.setBlock(x + 15, y + 28, z + 19, Block5, 0, 3);
		world.setBlock(x + 16, y + 28, z + 19, Block5, 0, 3);
		world.setBlock(x + 15, y + 28, z + 20, Block5, 0, 3);
		world.setBlock(x + 16, y + 28, z + 20, Block5, 0, 3);
		world.setBlock(x + 2, y + 28, z + 21, Block7, 0, 3);
		world.setBlock(x + 3, y + 28, z + 21, Block5, 0, 3);
		world.setBlock(x + 4, y + 28, z + 21, Block5, 0, 3);
		world.setBlock(x + 12, y + 28, z + 21, Block5, 0, 3);
		world.setBlock(x + 13, y + 28, z + 21, Block5, 0, 3);
		world.setBlock(x + 14, y + 28, z + 21, Block5, 0, 3);
		world.setBlock(x + 5, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 6, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 7, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 8, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 9, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 10, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 11, y + 28, z + 22, Block5, 0, 3);
		world.setBlock(x + 5, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 6, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 7, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 8, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 9, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 10, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 11, y + 29, z + 2, Block5, 0, 3);
		world.setBlock(x + 3, y + 29, z + 3, Block7, 0, 3);
		world.setBlock(x + 4, y + 29, z + 3, Block5, 0, 3);
		world.setBlock(x + 12, y + 29, z + 3, Block5, 0, 3);
		world.setBlock(x + 13, y + 29, z + 3, Block5, 0, 3);
		world.setBlock(x + 14, y + 29, z + 3, Block5, 0, 3);
		world.setBlock(x + 15, y + 29, z + 4, Block5, 0, 3);
		world.setBlock(x + 16, y + 29, z + 4, Block5, 0, 3);
		world.setBlock(x + 16, y + 29, z + 5, Block5, 0, 3);
		world.setBlock(x + 17, y + 29, z + 6, Block5, 0, 3);
		world.setBlock(x + 17, y + 29, z + 7, Block5, 0, 3);
		world.setBlock(x + 17, y + 29, z + 8, Block5, 0, 3);
		world.setBlock(x + 18, y + 29, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 29, z + 9, dSteel, 0, 3);
		world.setBlock(x + 21, y + 29, z + 9, dSteel, 0, 3);
		world.setBlock(x + 22, y + 29, z + 9, dSteel, 0, 3);
		world.setBlock(x + 18, y + 29, z + 10, Block5, 0, 3);
		world.setBlock(x + 19, y + 29, z + 10, dSteel, 0, 3);
		world.setBlock(x + 20, y + 29, z + 10, dSteel, 0, 3);
		world.setBlock(x + 21, y + 29, z + 10, dSteel, 0, 3);
		world.setBlock(x + 18, y + 29, z + 11, Block5, 0, 3);
		world.setBlock(x + 21, y + 29, z + 11, dSteel, 0, 3);
		world.setBlock(x + 9, y + 29, z + 12, Block4, 0, 3);
		world.setBlock(x + 18, y + 29, z + 12, Block5, 0, 3);
		world.setBlock(x + 21, y + 29, z + 12, dSteel, 0, 3);
		world.setBlock(x + 18, y + 29, z + 13, Block5, 0, 3);
		world.setBlock(x + 21, y + 29, z + 13, dSteel, 0, 3);
		world.setBlock(x + 18, y + 29, z + 14, Block5, 0, 3);
		world.setBlock(x + 19, y + 29, z + 14, dSteel, 0, 3);
		world.setBlock(x + 20, y + 29, z + 14, dSteel, 0, 3);
		world.setBlock(x + 21, y + 29, z + 14, dSteel, 0, 3);
		world.setBlock(x + 18, y + 29, z + 15, Block5, 0, 3);
		world.setBlock(x + 20, y + 29, z + 15, dSteel, 0, 3);
		world.setBlock(x + 21, y + 29, z + 15, dSteel, 0, 3);
		world.setBlock(x + 22, y + 29, z + 15, dSteel, 0, 3);
		world.setBlock(x + 17, y + 29, z + 16, Block5, 0, 3);
		world.setBlock(x + 17, y + 29, z + 17, Block5, 0, 3);
		world.setBlock(x + 17, y + 29, z + 18, Block5, 0, 3);
		world.setBlock(x + 16, y + 29, z + 19, Block5, 0, 3);
		world.setBlock(x + 15, y + 29, z + 20, Block5, 0, 3);
		world.setBlock(x + 16, y + 29, z + 20, Block5, 0, 3);
		world.setBlock(x + 3, y + 29, z + 21, Block7, 0, 3);
		world.setBlock(x + 4, y + 29, z + 21, Block5, 0, 3);
		world.setBlock(x + 12, y + 29, z + 21, Block5, 0, 3);
		world.setBlock(x + 13, y + 29, z + 21, Block5, 0, 3);
		world.setBlock(x + 14, y + 29, z + 21, Block5, 0, 3);
		world.setBlock(x + 5, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 6, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 7, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 8, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 9, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 10, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 11, y + 29, z + 22, Block5, 0, 3);
		world.setBlock(x + 5, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 6, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 7, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 8, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 9, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 10, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 11, y + 30, z + 1, Block5, 0, 3);
		world.setBlock(x + 4, y + 30, z + 2, Block7, 0, 3);
		world.setBlock(x + 12, y + 30, z + 2, Block5, 0, 3);
		world.setBlock(x + 13, y + 30, z + 2, Block5, 0, 3);
		world.setBlock(x + 14, y + 30, z + 2, Block5, 0, 3);
		world.setBlock(x + 15, y + 30, z + 3, Block5, 0, 3);
		world.setBlock(x + 16, y + 30, z + 3, Block5, 0, 3);
		world.setBlock(x + 17, y + 30, z + 4, Block5, 0, 3);
		world.setBlock(x + 17, y + 30, z + 5, Block5, 0, 3);
		world.setBlock(x + 18, y + 30, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 30, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 30, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 30, z + 9, Block5, 0, 3);
		world.setBlock(x + 21, y + 30, z + 9, dSteel, 0, 3);
		world.setBlock(x + 19, y + 30, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 30, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 30, z + 11, Block5, 0, 3);
		world.setBlock(x + 8, y + 30, z + 12, Block4, 0, 3);
		world.setBlock(x + 9, y + 30, z + 12, Block4, 0, 3);
		world.setBlock(x + 19, y + 30, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 30, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 30, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 30, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 30, z + 15, Block5, 0, 3);
		world.setBlock(x + 21, y + 30, z + 15, dSteel, 0, 3);
		world.setBlock(x + 18, y + 30, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 30, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 30, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 30, z + 19, Block5, 0, 3);
		world.setBlock(x + 17, y + 30, z + 20, Block5, 0, 3);
		world.setBlock(x + 15, y + 30, z + 21, Block5, 0, 3);
		world.setBlock(x + 16, y + 30, z + 21, Block5, 0, 3);
		world.setBlock(x + 4, y + 30, z + 22, Block7, 0, 3);
		world.setBlock(x + 12, y + 30, z + 22, Block5, 0, 3);
		world.setBlock(x + 13, y + 30, z + 22, Block5, 0, 3);
		world.setBlock(x + 14, y + 30, z + 22, Block5, 0, 3);
		world.setBlock(x + 5, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 6, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 7, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 8, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 9, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 10, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 11, y + 30, z + 23, Block5, 0, 3);
		world.setBlock(x + 5, y + 31, z + 1, Block7, 0, 3);
		world.setBlock(x + 6, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 7, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 8, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 9, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 10, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 11, y + 31, z + 1, Block5, 0, 3);
		world.setBlock(x + 12, y + 31, z + 2, Block5, 0, 3);
		world.setBlock(x + 13, y + 31, z + 2, Block5, 0, 3);
		world.setBlock(x + 14, y + 31, z + 2, Block5, 0, 3);
		world.setBlock(x + 15, y + 31, z + 3, Block5, 0, 3);
		world.setBlock(x + 16, y + 31, z + 3, Block5, 0, 3);
		world.setBlock(x + 17, y + 31, z + 4, Block5, 0, 3);
		world.setBlock(x + 17, y + 31, z + 5, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 31, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 31, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 31, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 31, z + 11, Block5, 0, 3);
		world.setBlock(x + 8, y + 31, z + 12, Block4, 0, 3);
		world.setBlock(x + 19, y + 31, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 31, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 31, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 31, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 31, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 31, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 31, z + 19, Block5, 0, 3);
		world.setBlock(x + 17, y + 31, z + 20, Block5, 0, 3);
		world.setBlock(x + 15, y + 31, z + 21, Block5, 0, 3);
		world.setBlock(x + 16, y + 31, z + 21, Block5, 0, 3);
		world.setBlock(x + 12, y + 31, z + 22, Block5, 0, 3);
		world.setBlock(x + 13, y + 31, z + 22, Block5, 0, 3);
		world.setBlock(x + 14, y + 31, z + 22, Block5, 0, 3);
		world.setBlock(x + 5, y + 31, z + 23, Block7, 0, 3);
		world.setBlock(x + 6, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 7, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 8, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 9, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 10, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 11, y + 31, z + 23, Block5, 0, 3);
		world.setBlock(x + 6, y + 32, z + 1, Block7, 0, 3);
		world.setBlock(x + 7, y + 32, z + 1, Block5, 0, 3);
		world.setBlock(x + 8, y + 32, z + 1, Block5, 0, 3);
		world.setBlock(x + 9, y + 32, z + 1, Block5, 0, 3);
		world.setBlock(x + 10, y + 32, z + 1, Block5, 0, 3);
		world.setBlock(x + 11, y + 32, z + 1, Block5, 0, 3);
		world.setBlock(x + 12, y + 32, z + 2, Block5, 0, 3);
		world.setBlock(x + 13, y + 32, z + 2, Block5, 0, 3);
		world.setBlock(x + 14, y + 32, z + 2, Block5, 0, 3);
		world.setBlock(x + 15, y + 32, z + 3, Block5, 0, 3);
		world.setBlock(x + 16, y + 32, z + 3, Block5, 0, 3);
		world.setBlock(x + 17, y + 32, z + 4, Block5, 0, 3);
		world.setBlock(x + 17, y + 32, z + 5, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 32, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 32, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 32, z + 10, dSteel, 0, 3);
		world.setBlock(x + 19, y + 32, z + 11, Block5, 0, 3);
		world.setBlock(x + 7, y + 32, z + 12, Block4, 0, 3);
		world.setBlock(x + 8, y + 32, z + 12, Block4, 0, 3);
		world.setBlock(x + 19, y + 32, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 32, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 32, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 32, z + 14, dSteel, 0, 3);
		world.setBlock(x + 19, y + 32, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 32, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 32, z + 19, Block5, 0, 3);
		world.setBlock(x + 17, y + 32, z + 20, Block5, 0, 3);
		world.setBlock(x + 15, y + 32, z + 21, Block5, 0, 3);
		world.setBlock(x + 16, y + 32, z + 21, Block5, 0, 3);
		world.setBlock(x + 12, y + 32, z + 22, Block5, 0, 3);
		world.setBlock(x + 13, y + 32, z + 22, Block5, 0, 3);
		world.setBlock(x + 14, y + 32, z + 22, Block5, 0, 3);
		world.setBlock(x + 6, y + 32, z + 23, Block7, 0, 3);
		world.setBlock(x + 7, y + 32, z + 23, Block5, 0, 3);
		world.setBlock(x + 8, y + 32, z + 23, Block5, 0, 3);
		world.setBlock(x + 9, y + 32, z + 23, Block5, 0, 3);
		world.setBlock(x + 10, y + 32, z + 23, Block5, 0, 3);
		world.setBlock(x + 11, y + 32, z + 23, Block5, 0, 3);
		world.setBlock(x + 7, y + 33, z + 0, Block7, 0, 3);
		world.setBlock(x + 8, y + 33, z + 0, Block5, 0, 3);
		world.setBlock(x + 9, y + 33, z + 0, Block5, 0, 3);
		world.setBlock(x + 10, y + 33, z + 0, Block5, 0, 3);
		world.setBlock(x + 11, y + 33, z + 0, Block5, 0, 3);
		world.setBlock(x + 12, y + 33, z + 1, Block5, 0, 3);
		world.setBlock(x + 13, y + 33, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 33, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 33, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 33, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 33, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 33, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 33, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 11, Block5, 0, 3);
		world.setBlock(x + 7, y + 33, z + 12, Block4, 0, 3);
		world.setBlock(x + 18, y + 33, z + 12, Block4, 0, 3);
		world.setBlock(x + 19, y + 33, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 33, z + 12, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 33, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 33, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 33, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 33, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 33, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 33, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 33, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 33, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 33, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 33, z + 23, Block5, 0, 3);
		world.setBlock(x + 7, y + 33, z + 24, Block7, 0, 3);
		world.setBlock(x + 8, y + 33, z + 24, Block5, 0, 3);
		world.setBlock(x + 9, y + 33, z + 24, Block5, 0, 3);
		world.setBlock(x + 10, y + 33, z + 24, Block5, 0, 3);
		world.setBlock(x + 11, y + 33, z + 24, Block5, 0, 3);
		world.setBlock(x + 8, y + 34, z + 0, Block7, 0, 3);
		world.setBlock(x + 9, y + 34, z + 0, Block5, 0, 3);
		world.setBlock(x + 10, y + 34, z + 0, Block5, 0, 3);
		world.setBlock(x + 11, y + 34, z + 0, Block5, 0, 3);
		world.setBlock(x + 12, y + 34, z + 1, Block5, 0, 3);
		world.setBlock(x + 13, y + 34, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 34, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 34, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 34, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 34, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 34, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 34, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 11, Block5, 0, 3);
		world.setBlock(x + 6, y + 34, z + 12, Block4, 0, 3);
		world.setBlock(x + 7, y + 34, z + 12, Block4, 0, 3);
		world.setBlock(x + 16, y + 34, z + 12, Block4, 0, 3);
		world.setBlock(x + 17, y + 34, z + 12, Block4, 0, 3);
		world.setBlock(x + 18, y + 34, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 34, z + 12, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 34, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 34, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 34, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 34, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 34, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 34, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 34, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 34, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 34, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 34, z + 23, Block5, 0, 3);
		world.setBlock(x + 8, y + 34, z + 24, Block7, 0, 3);
		world.setBlock(x + 9, y + 34, z + 24, Block5, 0, 3);
		world.setBlock(x + 10, y + 34, z + 24, Block5, 0, 3);
		world.setBlock(x + 11, y + 34, z + 24, Block5, 0, 3);
		world.setBlock(x + 9, y + 35, z + 0, Block7, 0, 3);
		world.setBlock(x + 10, y + 35, z + 0, Block5, 0, 3);
		world.setBlock(x + 11, y + 35, z + 0, Block5, 0, 3);
		world.setBlock(x + 12, y + 35, z + 1, Block5, 0, 3);
		world.setBlock(x + 13, y + 35, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 35, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 35, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 35, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 35, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 35, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 35, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 11, Block5, 0, 3);
		world.setBlock(x + 6, y + 35, z + 12, Block4, 0, 3);
		world.setBlock(x + 14, y + 35, z + 12, Block4, 0, 3);
		world.setBlock(x + 15, y + 35, z + 12, Block4, 0, 3);
		world.setBlock(x + 16, y + 35, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 35, z + 12, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 35, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 35, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 35, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 35, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 35, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 35, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 35, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 35, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 35, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 35, z + 23, Block5, 0, 3);
		world.setBlock(x + 9, y + 35, z + 24, Block7, 0, 3);
		world.setBlock(x + 10, y + 35, z + 24, Block5, 0, 3);
		world.setBlock(x + 11, y + 35, z + 24, Block5, 0, 3);
		world.setBlock(x + 10, y + 36, z + 0, Block7, 0, 3);
		world.setBlock(x + 11, y + 36, z + 0, Block5, 0, 3);
		world.setBlock(x + 12, y + 36, z + 1, Block5, 0, 3);
		world.setBlock(x + 13, y + 36, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 36, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 36, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 36, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 36, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 36, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 36, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 11, Block5, 0, 3);
		world.setBlock(x + 5, y + 36, z + 12, Block4, 0, 3);
		world.setBlock(x + 6, y + 36, z + 12, Block4, 0, 3);
		world.setBlock(x + 12, y + 36, z + 12, Block4, 0, 3);
		world.setBlock(x + 13, y + 36, z + 12, Block4, 0, 3);
		world.setBlock(x + 14, y + 36, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 36, z + 12, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 36, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 36, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 36, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 36, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 36, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 36, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 36, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 36, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 36, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 36, z + 23, Block5, 0, 3);
		world.setBlock(x + 10, y + 36, z + 24, Block7, 0, 3);
		world.setBlock(x + 11, y + 36, z + 24, Block5, 0, 3);
		world.setBlock(x + 11, y + 37, z + 0, Block7, 0, 3);
		world.setBlock(x + 12, y + 37, z + 1, Block5, 0, 3);
		world.setBlock(x + 13, y + 37, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 37, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 37, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 37, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 37, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 37, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 37, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 10, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 11, Block5, 0, 3);
		world.setBlock(x + 5, y + 37, z + 12, Block4, 0, 3);
		world.setBlock(x + 10, y + 37, z + 12, Block4, 0, 3);
		world.setBlock(x + 11, y + 37, z + 12, Block4, 0, 3);
		world.setBlock(x + 12, y + 37, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 37, z + 12, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 37, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 37, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 37, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 37, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 37, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 37, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 37, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 37, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 37, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 37, z + 23, Block5, 0, 3);
		world.setBlock(x + 11, y + 37, z + 24, Block7, 0, 3);
		world.setBlock(x + 12, y + 38, z + 1, Block7, 0, 3);
		world.setBlock(x + 13, y + 38, z + 1, Block5, 0, 3);
		world.setBlock(x + 14, y + 38, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 38, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 38, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 38, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 38, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 38, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 38, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 38, z + 10, Block5, 0, 3);
		world.setBlock(x + 4, y + 38, z + 11, Block7, 0, 3);
		world.setBlock(x + 5, y + 38, z + 11, Block7, 0, 3);
		world.setBlock(x + 6, y + 38, z + 11, Block7, 0, 3);
		world.setBlock(x + 20, y + 38, z + 11, Block5, 0, 3);
		world.setBlock(x + 4, y + 38, z + 12, Block7, 0, 3);
		world.setBlock(x + 5, y + 38, z + 12, Block7, 0, 3);
		world.setBlock(x + 6, y + 38, z + 12, Block7, 0, 3);
		world.setBlock(x + 8, y + 38, z + 12, Block4, 0, 3);
		world.setBlock(x + 9, y + 38, z + 12, Block4, 0, 3);
		world.setBlock(x + 10, y + 38, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 38, z + 12, Block5, 0, 3);
		world.setBlock(x + 4, y + 38, z + 13, Block7, 0, 3);
		world.setBlock(x + 5, y + 38, z + 13, Block7, 0, 3);
		world.setBlock(x + 6, y + 38, z + 13, Block7, 0, 3);
		world.setBlock(x + 20, y + 38, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 38, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 38, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 38, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 38, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 38, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 38, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 38, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 38, z + 22, Block5, 0, 3);
		world.setBlock(x + 12, y + 38, z + 23, Block7, 0, 3);
		world.setBlock(x + 13, y + 38, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 38, z + 23, Block5, 0, 3);
		world.setBlock(x + 13, y + 39, z + 1, Block7, 0, 3);
		world.setBlock(x + 14, y + 39, z + 1, Block5, 0, 3);
		world.setBlock(x + 15, y + 39, z + 2, Block5, 0, 3);
		world.setBlock(x + 16, y + 39, z + 2, Block5, 0, 3);
		world.setBlock(x + 17, y + 39, z + 3, Block5, 0, 3);
		world.setBlock(x + 18, y + 39, z + 4, Block5, 0, 3);
		world.setBlock(x + 18, y + 39, z + 5, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 6, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 7, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 8, Block5, 0, 3);
		world.setBlock(x + 20, y + 39, z + 9, Block5, 0, 3);
		world.setBlock(x + 20, y + 39, z + 10, Block5, 0, 3);
		world.setBlock(x + 4, y + 39, z + 11, Block7, 0, 3);
		world.setBlock(x + 5, y + 39, z + 11, Block7, 0, 3);
		world.setBlock(x + 6, y + 39, z + 11, Block7, 0, 3);
		world.setBlock(x + 20, y + 39, z + 11, Block5, 0, 3);
		world.setBlock(x + 4, y + 39, z + 12, Block7, 0, 3);
		//world.setBlock(x + 5, y + 39, z + 12, Block7, 0, 3);
		world.setBlock(x + 5, y + 39, z + 12, Blocks.chest, 4, 3);
		world.setBlockMetadataWithNotify(x + 5, y + 39, z + 12, 4, 3);
        WeightedRandomChestContent.generateChestContents(rand, HbmChestContents.expensive, (TileEntityChest)world.getTileEntity(x + 5, y + 39, z + 12), 12);
		world.setBlock(x + 6, y + 39, z + 12, Block7, 0, 3);
		world.setBlock(x + 7, y + 39, z + 12, Block4, 0, 3);
		world.setBlock(x + 8, y + 39, z + 12, Block4, 0, 3);
		world.setBlock(x + 20, y + 39, z + 12, Block5, 0, 3);
		world.setBlock(x + 4, y + 39, z + 13, Block7, 0, 3);
		world.setBlock(x + 5, y + 39, z + 13, Block7, 0, 3);
		world.setBlock(x + 6, y + 39, z + 13, Block7, 0, 3);
		world.setBlock(x + 20, y + 39, z + 13, Block5, 0, 3);
		world.setBlock(x + 20, y + 39, z + 14, Block5, 0, 3);
		world.setBlock(x + 20, y + 39, z + 15, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 16, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 17, Block5, 0, 3);
		world.setBlock(x + 19, y + 39, z + 18, Block5, 0, 3);
		world.setBlock(x + 18, y + 39, z + 19, Block5, 0, 3);
		world.setBlock(x + 18, y + 39, z + 20, Block5, 0, 3);
		world.setBlock(x + 17, y + 39, z + 21, Block5, 0, 3);
		world.setBlock(x + 15, y + 39, z + 22, Block5, 0, 3);
		world.setBlock(x + 16, y + 39, z + 22, Block5, 0, 3);
		world.setBlock(x + 13, y + 39, z + 23, Block7, 0, 3);
		world.setBlock(x + 14, y + 39, z + 23, Block5, 0, 3);
		world.setBlock(x + 14, y + 40, z + 2, Block7, 0, 3);
		world.setBlock(x + 15, y + 40, z + 3, Block5, 0, 3);
		world.setBlock(x + 16, y + 40, z + 3, Block5, 0, 3);
		world.setBlock(x + 17, y + 40, z + 4, Block5, 0, 3);
		world.setBlock(x + 17, y + 40, z + 5, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 40, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 40, z + 10, Block5, 0, 3);
		world.setBlock(x + 4, y + 40, z + 11, Block7, 0, 3);
		world.setBlock(x + 5, y + 40, z + 11, Block7, 0, 3);
		world.setBlock(x + 6, y + 40, z + 11, Block7, 0, 3);
		world.setBlock(x + 19, y + 40, z + 11, Block5, 0, 3);
		world.setBlock(x + 4, y + 40, z + 12, Block7, 0, 3);
		world.setBlock(x + 5, y + 40, z + 12, Block7, 0, 3);
		world.setBlock(x + 6, y + 40, z + 12, Block7, 0, 3);
		world.setBlock(x + 19, y + 40, z + 12, Block5, 0, 3);
		world.setBlock(x + 4, y + 40, z + 13, Block7, 0, 3);
		world.setBlock(x + 5, y + 40, z + 13, Block7, 0, 3);
		world.setBlock(x + 6, y + 40, z + 13, Block7, 0, 3);
		world.setBlock(x + 19, y + 40, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 40, z + 14, Block5, 0, 3);
		world.setBlock(x + 19, y + 40, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 40, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 40, z + 19, Block5, 0, 3);
		world.setBlock(x + 17, y + 40, z + 20, Block5, 0, 3);
		world.setBlock(x + 15, y + 40, z + 21, Block5, 0, 3);
		world.setBlock(x + 16, y + 40, z + 21, Block5, 0, 3);
		world.setBlock(x + 14, y + 40, z + 22, Block7, 0, 3);
		world.setBlock(x + 15, y + 41, z + 3, Block7, 0, 3);
		world.setBlock(x + 16, y + 41, z + 3, Block5, 0, 3);
		world.setBlock(x + 17, y + 41, z + 4, Block5, 0, 3);
		world.setBlock(x + 17, y + 41, z + 5, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 10, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 11, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 14, Block5, 0, 3);
		world.setBlock(x + 19, y + 41, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 41, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 41, z + 19, Block5, 0, 3);
		world.setBlock(x + 17, y + 41, z + 20, Block5, 0, 3);
		world.setBlock(x + 15, y + 41, z + 21, Block7, 0, 3);
		world.setBlock(x + 16, y + 41, z + 21, Block5, 0, 3);
		world.setBlock(x + 16, y + 42, z + 3, Block7, 0, 3);
		world.setBlock(x + 17, y + 42, z + 4, Block7, 0, 3);
		world.setBlock(x + 17, y + 42, z + 5, Block7, 0, 3);
		world.setBlock(x + 18, y + 42, z + 6, Block5, 0, 3);
		world.setBlock(x + 18, y + 42, z + 7, Block5, 0, 3);
		world.setBlock(x + 18, y + 42, z + 8, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 9, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 10, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 11, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 12, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 13, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 14, Block5, 0, 3);
		world.setBlock(x + 19, y + 42, z + 15, Block5, 0, 3);
		world.setBlock(x + 18, y + 42, z + 16, Block5, 0, 3);
		world.setBlock(x + 18, y + 42, z + 17, Block5, 0, 3);
		world.setBlock(x + 18, y + 42, z + 18, Block5, 0, 3);
		world.setBlock(x + 17, y + 42, z + 19, Block7, 0, 3);
		world.setBlock(x + 17, y + 42, z + 20, Block7, 0, 3);
		world.setBlock(x + 16, y + 42, z + 21, Block7, 0, 3);
		world.setBlock(x + 17, y + 43, z + 6, Block7, 0, 3);
		world.setBlock(x + 17, y + 43, z + 7, Block7, 0, 3);
		world.setBlock(x + 17, y + 43, z + 8, Block7, 0, 3);
		world.setBlock(x + 18, y + 43, z + 9, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 10, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 11, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 12, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 13, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 14, Block5, 0, 3);
		world.setBlock(x + 18, y + 43, z + 15, Block5, 0, 3);
		world.setBlock(x + 17, y + 43, z + 16, Block7, 0, 3);
		world.setBlock(x + 17, y + 43, z + 17, Block7, 0, 3);
		world.setBlock(x + 17, y + 43, z + 18, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 9, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 10, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 11, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 12, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 13, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 14, Block7, 0, 3);
		world.setBlock(x + 18, y + 44, z + 15, Block7, 0, 3);

		generate_r03_last(world, rand, x, y, z);
		return true;

	}
	public boolean generate_r03_last(World world, Random rand, int x, int y, int z) {

		world.setBlock(x + 19, y + 3, z + 9, Blocks.torch, 4, 3);
		world.setBlock(x + 6, y + 10, z + 17, Blocks.torch, 2, 3);
		world.setBlock(x + 9, y + 15, z + 19, Blocks.torch, 3, 3);
		world.setBlock(x + 17, y + 15, z + 19, Blocks.torch, 3, 3);
		world.setBlock(x + 13, y + 15, z + 24, Blocks.torch, 5, 3);
		world.setBlock(x + 9, y + 15, z + 27, Blocks.torch, 4, 3);
		world.setBlock(x + 17, y + 15, z + 27, Blocks.torch, 4, 3);
		world.setBlock(x + 19, y + 19, z + 9, Blocks.torch, 4, 3);
		world.setBlock(x + 16, y + 19, z + 12, Blocks.torch, 2, 3);
		world.setBlock(x + 22, y + 19, z + 12, Blocks.torch, 1, 3);
		world.setBlock(x + 19, y + 19, z + 15, Blocks.torch, 3, 3);
		LootGenerator.setBlock(world, x + 13, y + 15, z + 23);
		LootGenerator.lootMedicine(world, x + 13, y + 15, z + 23);
		
		if(GeneralConfig.enableDebugMode)
			System.out.print("[Debug] Successfully spawned satellite dish at " + x + " " + y +" " + z + "\n");
		return true;

	}

}